/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.action;

import java.util.Date;

import jp.mosp.common.common.BaseAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dao.CmUserDao;
import jp.mosp.common.dto.CmUserDto;
import jp.mosp.common.vo.PasswordVo;

/**
 * パスワード変更画面における処理を行う。<br><br>
 */
public class PasswordAction extends BaseAction {
	
	// コマンド
	private static final String CMD_PASSWORD_SHOW   = "C1050";
	private static final String CMD_PASSWORD_CHANGE = "C1051";
	private static final String CMD_PASS_FORCE      = MospConst.CMD_PASS_FORCE;
	
	/**
	 * コンストラクタ。<br>
	 * 権限確認不要を設定する。<br>
	 */
	public PasswordAction() {
		super();
		// 共通処理設定
		setCheckAuth   (false);
	}
	
	/**
	 * アクション。<br>
	 */
	public void action() throws Exception {
		// VO準備
		prepareVo();
		// メニューコマンド設定
		setCmdMenu();
		// コマンド毎の処理
		if (cmd.equals(CMD_PASSWORD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_PASSWORD_CHANGE)) {
			// 更新
			update();
		} else if (cmd.equals(CMD_PASS_FORCE)) {
			// 表示(強制パスワード変更)
			showForce();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new PasswordVo(cfg, msg, nam, cmd, aspUser, user);
	}
	
	/**
	 * 表示処理。<br>
	 * ログインユーザーのユーザーID、ユーザー名を設定する。<br>
	 * @throws Exception
	 */
	protected void show() throws Exception {
		// VO準備
		chkInstance(getVo() instanceof PasswordVo);
		PasswordVo vo = (PasswordVo)getVo();
		// 情報設定
		vo.setUserId  (user.getUserId  ());
		vo.setUserName(user.getUserName());
		// メニューへボタンの表示
		vo.setMode(PasswordVo.MODE_SHOW);
	}
	
	/**
	 * 表示処理(強制パスワード変更)。<br>
	 * ログインユーザーのユーザーID、ユーザー名を設定する。<br>
	 * @throws Exception
	 */
	protected void showForce() throws Exception {
		// VO準備
		chkInstance(getVo() instanceof PasswordVo);
		PasswordVo vo = (PasswordVo)getVo();
		// 情報設定
		vo.setUserId  (user.getUserId  ());
		vo.setUserName(user.getUserName());
		// メニューへボタンの表示
		vo.setMode(PasswordVo.MODE_FORCE_UPDATE);
	}
	
	/**
	 * データ更新
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void update() throws Exception {
		// VO準備
		chkInstance(getVo() instanceof PasswordVo);
		PasswordVo vo = (PasswordVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// コネクションの取得及びDAOの準備
		getConnection();
		CmUserDao dao = new CmUserDao(cfg, cmd, aspUser, user, conn);
		// DTOの準備
		CmUserDto dto = dao.findForUpdate(vo.getUserId());
		// 存在確認
		chkExist(dto);
		// パラメータの妥当性確認
		vo.validate(dto.getPassword());
		// 値の設定
		dto.setPassword(MospUtility.encrypt(vo.getHdnNewPassword(), hasMospSeJar()));
		// パスワード変更日時をセットする。
		dto.setChangePass(new Date());
		// データの更新
		dao.update(dto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		// メニューへボタンの表示
		vo.setMode(PasswordVo.MODE_SHOW);
	}

	/**
	 * メニューコマンド設定
	 * @param vo 設定対象VO
	 * @throws MospException 
	 */
	private void setCmdMenu() throws MospException {
		// VO準備
		chkInstance(getVo() instanceof PasswordVo);
		PasswordVo vo = (PasswordVo)getVo();
		// 権限による設定
		if (user.getAuthority().equals(MospConst.AUTH_MOSP_ADMIN)) {
			vo.setCmdMenu(MospConst.CMD_ADMIN_MENU);
		} else {
			vo.setCmdMenu(MospConst.CMD_MENU);
		}
	}

}
